--
-- Schlepptrailer
-- Autor: Hewaaa
-- Date: 29.12.2012
-- published for www.ls2011.org
-- 


Schlepptrailer = {};

function Schlepptrailer.prerequisitesPresent(specializations)
    return true;
end;

function Schlepptrailer:load(xmlFile)	
	self.PlayerTriggerCallback = Schlepptrailer.PlayerTriggerCallback;
	self.trigger = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.PlayerTrigger#index"));	
	addTrigger(self.trigger, "PlayerTriggerCallback", self);
    self.deleteListenerId = addDeleteListener(self.trigger, "delete", self);

	self.PlayerinTrigger = false;

	self.RotComp = {getWorldRotation(self.components[1].node)};
end;

function Schlepptrailer:delete()
    removeTrigger(self.trigger);
    removeDeleteListener(self.trigger, self.deleteListenerId);
end;

function Schlepptrailer:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Schlepptrailer:keyEvent(unicode, sym, modifier, isDown)
end;

function Schlepptrailer:update(dt)

	local x,y,z = getWorldRotation(self.components[1].node);
	if x ~= self.RotComp[1] or y ~= self.RotComp[2] or z ~= self.RotComp[1] then
		self.RotComp = {x,y,z};
		for _, part in pairs(self.movingParts) do
			part.isDirty = true;
		end;
	end;

	if self.PlayerinTrigger == true then 
		
		if InputBinding.hasEvent(InputBinding.Schlepptrailer_1) then
			if self.Upper then
				self:setAnimationTime(1, self.animationParts[1].offSet, false);
			else
				self:setAnimationTime(1, self.animationParts[1].animDuration, false);
			end;
		end;

		if self.Upper then
			g_currentMission:addHelpButtonText(g_i18n:getText("Schlepptrailer_1"), InputBinding.Schlepptrailer_1);
		else
			g_currentMission:addHelpButtonText(g_i18n:getText("Schlepptrailer_2"), InputBinding.Schlepptrailer_1);
		end;	
	
	end;
	
	self.Upper = self.animationParts[1].clipEndTime and self.animationParts[1].inputDone;
end;



function Schlepptrailer:updateTick(dt)
 end;
 
function Schlepptrailer:PlayerTriggerCallback(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)

	if onEnter or onStay then
		if (g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode) then
			self.PlayerinTrigger = true;
			end;
		elseif onLeave then
			self.PlayerinTrigger = false;
	end;

end;

function Schlepptrailer:onAttach()
	setJointRotationLimit(self.componentJoints[1].jointIndex, 0, true);	
end;

function Schlepptrailer:onDetach()
	setJointRotationLimit(self.componentJoints[1].jointIndex, 0, true);
end;

function Schlepptrailer:draw()
end;
